import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.NoSuchElementException;
import java.util.Scanner;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.Timer;
import javax.swing.border.LineBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

public class Dipplc_chk implements ActionListener,ChangeListener{
	private SerialPort serialPort;	// シリアル通信用のクラス

//	private Scanner readData;	// 入力データを扱うBufferedReaderクラス
	private BufferedReader readData;	// 入力データを扱うBufferedReaderクラス
	private OutputStream writeData;	// 出力データを扱うOutputStreamクラス
	private Timer timer;
	private static String dev_str[] = {"X","Y","M","D","T","C"};
	private int devno=0;
	
	JFrame frame;

	JButton[] button = new JButton[58];
	String btn_title[] = {
			"ポートサーチ","<html>通信<br>開く</html>","監視開始","監視停止","<html>通信<br>閉じる</html>","送信","実行","中断","再開","リセット",  //0-10
			"システム情報表示","削除","リスト要求","X04A","X05A","X04D","X05D","X問合せ","Y問合せ","M問合せ", // 11-20
			"D問合せ","T問合せ","C問合せ","X00?","X01?","X02?","X03?","X04?","X05?","Y00", // 21-30
			"Y01","Y02","Y03","Y04","Y05","Y00?","Y01?","Y02?","M00","M00?",				// 31-40
			"M01","M01?","M02","M02?","D00=0","D00?","D01=100","D01?","D01=x0","D01=x1F",	// 41-50
			"D01?","D02?","T00?","T01?","T02?","C00?","C01?","C02?","","",	// 51-60
			};
	Dimension[] btn_dim = {
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 0
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 6
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 10
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 16
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 20
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 26
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 30
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 36
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 40
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 46
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),	// 50
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 56
			new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40),new Dimension(40,40), // 56			
	};
	int[]	btn_allno={
			0, 0, 0, 0,0, 0, 0, 0, 0, 0,  // 0
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 10
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 20
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 30
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 50
	};
	int[]	btn_noport={
			1, 0, 0, 0,0, 0, 0, 0, 0, 0,  // 0
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 10
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 20
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 30
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 50
	};
	int[]	btn_acportno={
			1, 1, 0, 0,0, 0, 0, 0, 0, 0,  // 0
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 10
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 20
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 30
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 50
	};
	int[]	btn_acportop={
			0, 0, 1, 0, 1, 1, 1, 1, 1, 1,  // 0
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 10
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 20
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 30
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 40
			1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 50
	};
	int[]	btn_acportmon={
			0, 0, 0, 1, 0, 0, 0, 0, 0, 0,  // 0
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 10
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 20
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 30
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 40
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 50
	};
	int[]	pal_no={
			0, 6, 6, 6, 6, 7, 1, 1, 1, 1,  // 0
			1, 1, 1, 1, 1, 1, 1, 2, 2, 2,  // 10
			2, 2, 2, 3, 3, 3, 3, 3, 3, 99,  // 20
			99, 99, 99, 99, 99, 99, 3, 3, 99, 3,  // 30
			99, 3, 99, 3, 3, 3, 3, 3, 3, 3, // 40
			3, 3, 3, 3, 3, 3, 3, 3, 3, 3, // 50
	};
	int[]	pal_no_lbl={
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 0
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 10
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 20
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 30
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  	// 40
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  	// 50
	};
	Point[] panel_point={
			new Point(10,0),new Point(360,0),new Point(360,80),new Point(360,150),
			new Point(560,120),new Point(560,170),new Point(10,50),new Point(10,100),
			new Point(10,150)};
	Dimension[] panel_dim={
			new Dimension(350,40),new Dimension(500,80),new Dimension(500,50),new Dimension(200,450),
			new Dimension(470,50),new Dimension(470,450),new Dimension(350,40),new Dimension(350,40),
			new Dimension(350,450)};
	
	
	JPanel[] panel = new JPanel[9];
	String btn_panel[] = {
			"p1","p2","p3","p4","p5","p6","p7","p8",
	};
	
	JLabel list_lbl[] = new JLabel[6];
	String list_lbl_str[] = {"入力X","出力Y","<html>内部リレー<br>M</html>","<html>データ<br>レジスタD</html>","タイマT","カウンタC"};
	JList<String> list[] = new JList[6];
	DefaultListModel model[] = new DefaultListModel[6];
	
	Dimension[] list_dim={
			new Dimension(60,600),new Dimension(60,600),new Dimension(100,600),
			new Dimension(60,600),new Dimension(60,600),new Dimension(60,600),
	};
	
	JToggleButton tglbtn[] = new JToggleButton[6];
	int	tglstate[] = new int[tglbtn.length];
	JComboBox<String> cmbbox = new JComboBox<String>();
	JTextField txt = new JTextField(20);
	JTextArea txt_area = new JTextArea(10,10);
//	JList<String> lst_log = new JList<String>();
	JLabel lbl = new JLabel("てすと");

	protected enum Mode{
		NO_PORT,
		AC_PORT_NO,
		AC_PORT_OP,
		AC_PORT_MON,
		ALL_NO,
	}
	
	public Dipplc_chk(){
		frame = new JFrame("DIP_PLC チェックアプリケーション");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setLayout(null);

		for (int i=0; i<button.length;i++){
			button[i] = new JButton(btn_title[i]);
		    button[i].addActionListener(this);
//			button[i].setContentAreaFilled(false);
			button[i].setMaximumSize(btn_dim[i]);
			button[i].setFont(new Font(null,Font.PLAIN,11));
		}
		for (int i=0; i<tglbtn.length; i++){
			tglbtn[i] = new JToggleButton(btn_title[i+29]);
			tglbtn[i].setFont(new Font(null,Font.PLAIN,11));
			tglbtn[i].addChangeListener(this);
		}
		FlowLayout flow = new FlowLayout();
		for (int i=0; i<panel.length;i++){
			panel[i] = new JPanel();
			if (i==0){
				JLabel cmb_lbl = new JLabel("通信ポート");
				panel[i].add(cmb_lbl);
				cmbbox.setSize(new Dimension(400,20));
				panel[i].add(cmbbox);
			} else if(i==4){
				
			} else if (i==7){
				JLabel txt_lbl = new JLabel("送信コマンド");
				panel[i].add(txt_lbl);				
				panel[i].add(txt);
			} else if (i==8){
//				lst_log.setSize(new Dimension(330,400));
//				lst_log.setBorder(new LineBorder(Color.BLACK));
//				panel[i].add(lst_log);
//				txt_area.setSize(new Dimension(330,400));
				JLabel area_lbl = new JLabel("通信ログ");
				txt_area.setRows(10);
				txt_area.setColumns(50);
				txt_area.setLineWrap(true);
				JScrollPane scrollbar = new JScrollPane(
						txt_area,
						JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
						JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
				scrollbar.setBounds(panel_point[i].x,panel_point[i].y+20,350,450);
				txt_area.setBorder(new LineBorder(Color.BLACK));
//				txt_area.setAutoscrolls(true);
//				txt_area.setLocation(panel_point[i]);
				area_lbl.setBounds(panel_point[i].x,panel_point[i].y,350,20);
				frame.add(area_lbl);
				frame.add(scrollbar);
//				panel[i].add(txt_area);
			}
			for(int j=0; j<button.length; j++){
				if (pal_no[j]==i){
					if (pal_no[j]!=99){
						panel[i].add(button[j]);
					}
				}
			}
			frame.add(panel[i],"panel" + i);
			panel[i].setLocation(panel_point[i]);
			panel[i].setSize(panel_dim[i]);
			panel[i].setLayout(flow);
//			panel[i].setMaximumSize(panel_dim[i]);
		}
		for (int i=0; i<tglbtn.length; i++){
			panel[3].add(tglbtn[i]);
			tglstate[i] = 0;
		}
		for (int i=0; i<list.length; i++){
			list_lbl[i] = new JLabel(list_lbl_str[i]);
			list_lbl[i].setFont(new Font(null,Font.PLAIN,11));
			model[i] = new DefaultListModel();
			list[i] = new JList(model[i]);
			list[i].setSize(list_dim[i]);
			list[i].setBorder(new LineBorder(Color.BLACK));
		}
		GridLayout grid = new GridLayout(1,6);
		panel[4].setLayout(grid);
		panel[5].setLayout(grid);
		GridLayout grid2 = new GridLayout();
		panel[0].setLayout(grid2);
		panel[6].setLayout(grid2);
		panel[7].setLayout(grid2);
		panel[8].setLayout(grid2);
		for (int i=0;i<list.length;i++){
			panel[4].add(list_lbl[i]);
		}
		for (int i=0;i<list.length;i++){
			if (i==2){
				JScrollPane scrollbar = new JScrollPane(
						list[i],
						JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
						JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
				scrollbar.setSize(list_dim[i]);
				panel[5].add(scrollbar);
			} else {
				panel[5].add(list[i]);				
			}
		}
		frame.pack();
		frame.setSize(1050, 680);
		frame.setVisible(true);

		ButtonSet(Mode.NO_PORT);				
		
		PortSearch();
		if (cmbbox.getItemCount()>0){
			ButtonSet(Mode.AC_PORT_NO);
		} else {
			ButtonSet(Mode.NO_PORT);				
		}
		
		frame.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				// TODO 自動生成されたメソッド・スタブ
		    	if (serialPort != null){
			    	serialPort.close();
			    	serialPort=null;
		    	}		
			}			
		});
		
		for(;;){
			try {
				Thread.sleep(1000);
			} catch(Exception ex){
				ex.printStackTrace();
				System.exit(0);
			}
		}
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		String recv = "";
		// TODO 自動生成されたメソッド・スタブ
		if (e.getSource() == button[0]) {	// ポートサーチ
			PortSearch();
			if (cmbbox.getItemCount()>0){
				ButtonSet(Mode.AC_PORT_NO);
			} else {
				ButtonSet(Mode.NO_PORT);				
			}
		} else if (e.getSource() == button[1]){	// 通信開く
			PortOpen();
			ButtonSet(Mode.AC_PORT_OP);
		} else if (e.getSource() == button[2]){	// 監視開始
			MonitorStart();
			ButtonSet(Mode.AC_PORT_MON);
		} else if (e.getSource() == button[3]){	// 監視停止
			ButtonSet(Mode.AC_PORT_OP);
			MonitorStop();
		} else if (e.getSource() == button[4]){	// 通信閉じる
			PortClose();
			ButtonSet(Mode.AC_PORT_NO);
		} else if (e.getSource() == button[5]){	// 送信
			SendCmd(txt.getText());
		} else if (e.getSource() == button[6]){	// 実行
			SendCmd("R");
		} else if(e.getSource() == button[7]) {	// 中断
			SendByteCmd((byte)0x03);
		} else if(e.getSource() == button[8]) {	// 再開
			// 未サポートコマンド
		} else if(e.getSource() == button[9]) { // リセット
			SendCmd("@");
		} else if(e.getSource() == button[10]) {//システム情報表示
			SendCmd("V");
		} else if(e.getSource() == button[11]) {//削除
			SendCmd("NA");
		} else if(e.getSource() == button[12]) { // リスト要求
			SendCmd("L");
		} else if(e.getSource() == button[13]) { // X04A
			SendCmd("X04A");			
		} else if(e.getSource() == button[14]) { // X05A
			SendCmd("X05A");			
		} else if(e.getSource() == button[15]) { // X04D
			SendCmd("X04D");			
		} else if(e.getSource() == button[16]) { // X05D
			SendCmd("X05D");			
		} else if(e.getSource() == button[17]) { // X問合せ
			recv = SendCmd("X?");
			model[0].clear();
			model[0].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			String BitStr;
			for (int i=0; i<8;i++){
				BitStr = recv.substring(7-i,8-i);
				if (BitStr.equals("0")){
					model[0].addElement("X0" + i + ":" + "OFF");					
				} else {
					model[0].addElement("X0" + i + ":" + "ON");					
				}
			}
		} else if(e.getSource() == button[18]) { // Y問合せ
			recv = SendCmd("Y?");			
			model[1].clear();
			model[1].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			String BitStr;
			for (int i=0; i<6;i++){
				BitStr = recv.substring(7-i,8-i);
				if (BitStr.equals("0")){
					model[1].addElement("Y0" + i + ":" + "OFF");					
				} else {
					model[1].addElement("Y0" + i + ":" + "ON");					
				}
			}
		} else if(e.getSource() == button[19]) { // M問合せ
			recv = SendCmd("M?");			
			model[2].clear();
			model[2].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);

			recv = recv.replaceAll(" ", "");

			System.out.println(recv);
			String BitStr;
			for (int j=0; j<8; j++){
				for (int i=0; i<8;i++){
					BitStr = recv.substring(7-i + 8*j,8-i + 8*j);
					if (BitStr.equals("0")){
						model[2].addElement("M" + (i+j*8) + ":" + "OFF");					
					} else {
						model[2].addElement("M" + (i+j*8) + ":" + "ON");					
					}
				}
			}
			
		} else if(e.getSource() == button[20]) { // D問合せ
			recv = SendCmd("D?");			
			model[3].clear();
			model[3].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			recv = recv.replaceAll(" ", "");

			System.out.println(recv);
			String ValStr;
			int spos = recv.indexOf("(");
			int epos = recv.indexOf(")");
			for (int i=0; i<8;i++){
				ValStr = recv.substring(spos+1 ,epos);
				model[3].addElement("D" + i + ":" + ValStr);
				spos = recv.indexOf("(",spos+1);
				epos = recv.indexOf(")",epos+1);
								
			}
		} else if(e.getSource() == button[21]) { // T問合せ
			recv = SendCmd("T?");			
			model[4].clear();
			model[4].addElement(recv);
			System.out.println(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			recv = recv.replaceAll(" ", "");
			String BitStr;
			for (int j=0; j<2; j++){
				for (int i=0; i<8;i++){
					BitStr = recv.substring(7-i + 8*j,8-i + 8*j);
					if (BitStr.equals("0")){
						model[4].addElement("T" + (i+j*8) + ":" + "OFF");					
					} else {
						model[4].addElement("T" + (i+j*8) + ":" + "ON");					
					}
				}
			}
		} else if(e.getSource() == button[22]) { // C問合せ
			recv = SendCmd("C?");			
			model[5].clear();
			model[5].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			recv = recv.replaceAll(" ", "");
			String BitStr;
				for (int i=0; i<6;i++){
					BitStr = recv.substring(7-i ,8-i );
					if (BitStr.equals("0")){
						model[5].addElement("C" + i + ":" + "OFF");					
					} else {
						model[5].addElement("C" + i + ":" + "ON");					
					}
				}
		} else if(e.getSource() == button[23]) { // X00?
			SendCmd("X00?");			
		} else if(e.getSource() == button[24]) { // X01?
			SendCmd("X01?");			
		} else if(e.getSource() == button[25]) { // X02?
			SendCmd("X02?");			
		} else if(e.getSource() == button[26]) { // X03?
			SendCmd("X03?");			
		} else if(e.getSource() == button[27]) { // X04?
			SendCmd("X04?");			
		} else if(e.getSource() == button[28]) { // X05?
			SendCmd("X05?");			
		} else if(e.getSource() == button[29]) { // Y00
			
		} else if(e.getSource() == button[30]) { // Y01
			
		} else if(e.getSource() == button[31]) { // Y02
			
		} else if(e.getSource() == button[32]) { // Y03
			
		} else if(e.getSource() == button[33]) { // Y04
			
		} else if(e.getSource() == button[34]) { // Y05
			
		} else if(e.getSource() == button[35]) { // Y00?
			SendCmd("Y00?");			
		} else if(e.getSource() == button[36]) { // Y01?
			SendCmd("Y01?");			
		} else if(e.getSource() == button[37]) { // Y02?
			SendCmd("Y02?");			
		} else if(e.getSource() == button[38]) { // M00
			
		} else if(e.getSource() == button[39]) { // M00?
			SendCmd("M00?");			
		} else if(e.getSource() == button[40]) { // M01

		} else if(e.getSource() == button[41]) { // M01?
			SendCmd("M01?");					
		} else if(e.getSource() == button[42]) { // M02
			
		} else if(e.getSource() == button[43]) { // M02?
			SendCmd("M02?");			
		} else if(e.getSource() == button[44]) { // D00=0
			SendCmd("D00=0");
		} else if(e.getSource() == button[45]) { // D00?
			SendCmd("D00?");			
		} else if(e.getSource() == button[46]) { // D01=100
			SendCmd("D01=100");			
		} else if(e.getSource() == button[47]) { // D01?
			SendCmd("D01?");						
		} else if(e.getSource() == button[48]) { // D01=x0
			SendCmd("D01=0");			
		} else if(e.getSource() == button[49]) { // D01=x1F
			SendCmd("D01=x1F");			
		} else if(e.getSource() == button[50]) { // D01?
			SendCmd("D01?");
		} else if(e.getSource() == button[51]) { // D02?
			SendCmd("D02?");
		} else if(e.getSource() == button[52]) { // T00?
			SendCmd("T00?");
		} else if(e.getSource() == button[53]) { // T01?
			SendCmd("T01?");
		} else if(e.getSource() == button[54]) { // T02?
			SendCmd("T02?");
		} else if(e.getSource() == button[55]) { // C00?
			SendCmd("C00?");
		} else if(e.getSource() == button[56]) { // C01?
			SendCmd("C01?");
		} else if(e.getSource() == button[57]) { // C02?
			SendCmd("C02?");			
		} else if (e.getSource() == timer){
			recv = SendCmd(dev_str[devno]+"?");
			model[devno].clear();
			model[devno].addElement(recv);
			recv = recv.substring(recv.indexOf(":")+1);
			recv = recv.replaceAll(" ", "");
			
			if (devno==0){
				String BitStr;
				for (int i=0; i<8;i++){
					BitStr = recv.substring(7-i,8-i);
					if (BitStr.equals("0")){
						model[0].addElement("X0" + i + ":" + "OFF");					
					} else {
						model[0].addElement("X0" + i + ":" + "ON");					
					}
				}
				devno++;
			} else if(devno==1){
				String BitStr;
				for (int i=0; i<6;i++){
					BitStr = recv.substring(7-i,8-i);
					if (BitStr.equals("0")){
						model[1].addElement("Y0" + i + ":" + "OFF");					
					} else {
						model[1].addElement("Y0" + i + ":" + "ON");					
					}
				}
				devno++;
			} else if(devno==2){
				String BitStr;
				for (int j=0; j<8; j++){
					for (int i=0; i<8;i++){
						BitStr = recv.substring(7-i + 8*j,8-i + 8*j);
						if (BitStr.equals("0")){
							model[2].addElement("M" + (i+j*8) + ":" + "OFF");					
						} else {
							model[2].addElement("M" + (i+j*8) + ":" + "ON");					
						}
					}
				}
				devno++;
			} else if(devno==3){
				System.out.println(recv);
				String ValStr;
				int spos = recv.indexOf("(");
				int epos = recv.indexOf(")");
				for (int i=0; i<8;i++){
					ValStr = recv.substring(spos+1 ,epos);
					model[3].addElement("D" + i + ":" + ValStr);
					spos = recv.indexOf("(",spos+1);
					epos = recv.indexOf(")",epos+1);
									
				}
				devno++;
			} else if(devno==4){
				String BitStr;
				for (int j=0; j<2; j++){
					for (int i=0; i<8;i++){
						BitStr = recv.substring(7-i + 8*j,8-i + 8*j);
						if (BitStr.equals("0")){
							model[4].addElement("T" + (i+j*8) + ":" + "OFF");					
						} else {
							model[4].addElement("T" + (i+j*8) + ":" + "ON");					
						}
					}
				}
				devno++;
			} else if(devno==5){
				String BitStr;
				for (int i=0; i<6;i++){
					BitStr = recv.substring(7-i ,8-i );
					if (BitStr.equals("0")){
						model[5].addElement("C" + i + ":" + "OFF");					
					} else {
						model[5].addElement("C" + i + ":" + "ON");					
					}
				}
				devno = 0;
			}
		} else {
			
		}
		lbl.setText(e.getActionCommand());
	}	
	
	void PortSearch(){
	    cmbbox.removeAllItems();
	    for (int i=0; i<=15; i++){
		    try{
			    CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier("COM" + i);
				CommPort commPort = portIdentifier.open("EPLC",50);
				
				String buffer=null;
				System.out.println("COM"+i);
				if ( commPort instanceof SerialPort )	// commPortがSerialPortクラスなら
				{
					// ここから先初期化部分
					serialPort = (SerialPort) commPort;	// CommPortをシリアルポートに変換
					serialPort.setSerialPortParams(9600,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
					Scanner readData = new Scanner(commPort.getInputStream());
					writeData = commPort.getOutputStream();

					// SerialPortへデータの送信
					String msg = "\r\n"; // 送信プログラム
				    writeData.write(msg.getBytes("US-ASCII"));	// 文字列をバイト型配列に変換

				    // 応答時間待ち
					Thread.sleep(50); // すぐに返事があるとは限らないので50ms待ち
					
					buffer = readData.next();//　改行まで１行分読込
					System.out.println(buffer);
					if (buffer.equals("???")){
					    cmbbox.addItem("COM" + i);	// COMBOBOXに項目を追加						
					}
				}
		    } catch (gnu.io.NoSuchPortException e){
	
		    } catch (gnu.io.PortInUseException e) {
		    
		    } catch (gnu.io.UnsupportedCommOperationException e){

		    } catch (IOException e){

		    } catch (InterruptedException e){
		    	
		    } finally {
		    	if (serialPort != null){
		    		serialPort.close();
		    	}
		    }
	    }
	}
	
	void MonitorStart(){
        timer = new Timer(300,this);
        timer.start();		
	}
	void MonitorStop(){
		timer.stop();
	}
	void PortOpen(){
		if (cmbbox.getSelectedItem()!=null){			
		    try{
		    	String portName = cmbbox.getSelectedItem().toString();
		    	System.out.println("PortName:" + portName);
			    CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
				CommPort commPort = portIdentifier.open("EPLC",100);
				
				String buffer=null;
	
				if ( commPort instanceof SerialPort )	// commPortがSerialPortクラスなら
				{
					// ここから先初期化部分
					serialPort = (SerialPort) commPort;	// CommPortをシリアルポートに変換
					serialPort.setSerialPortParams(9600,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
					readData = new BufferedReader( new InputStreamReader(commPort.getInputStream()));
					writeData = commPort.getOutputStream();
				}
		    } catch (gnu.io.NoSuchPortException e){
	
		    } catch (gnu.io.PortInUseException e) {
		    
		    } catch (gnu.io.UnsupportedCommOperationException e){
	
		    } catch (IOException e){
	
		    } finally {
		    	
		    }		
		}
	}

	void PortClose(){
    	if (serialPort != null){
	    	serialPort.close();
	    	serialPort=null;
    	}
	}
	void ExeCmd(){
		
	}
	String SendCmd(String cmd){
		if (serialPort != null){
			String buffer="";
			try {
				// SerialPortへデータの送信
				
				String msg = cmd + "\r\n"; // 送信プログラム
			    writeData.write(msg.getBytes("US-ASCII"));	// 文字列をバイト型配列に変換
	
			    // 応答時間待ち
				Thread.sleep(200); // すぐに返事があるとは限らないので200ms待ち
				
				char indata[] = new char[1024];
				
				while(readData.ready()){
					readData.read(indata);
					buffer = buffer + new String(indata);
					System.out.println(buffer);
				}
			} catch (IOException e){
				e.printStackTrace();
			} catch (InterruptedException e){
				e.printStackTrace();
			} catch (NoSuchElementException e){
				e.printStackTrace();
			}
			txt_area.setText(txt_area.getText() + buffer);
			return buffer;
		} else {
			return null;
		}
	}
	String SendByteCmd(byte cmd){
		if (serialPort != null){
			String buffer="";
			try {
				// SerialPortへデータの送信
				
				byte[] msg= new byte[1];
				msg[0] = cmd;
			    writeData.write(msg,0,1);	// 
	
			    // 応答時間待ち
				Thread.sleep(100); // すぐに返事があるとは限らないので100ms待ち
				char indata[] = new char[1024];
				
				while(readData.ready()){
					readData.read(indata);
					buffer = buffer + new String(indata);
					System.out.println(buffer);
				}

			} catch (IOException e){
				e.printStackTrace();
				
			} catch (InterruptedException e){
				e.printStackTrace();
			} catch (NoSuchElementException e){
				e.printStackTrace();				
			}
			txt_area.setText(txt_area.getText() + buffer);
			return buffer;
		} else {
			return null;
		}
	}
	
	void ButtonSet(Mode no){
		int btn_set[];
		switch(no){
			case NO_PORT:
				btn_set = btn_noport;
				break;
			case AC_PORT_NO:
				btn_set = btn_acportno;
				break;
			case AC_PORT_OP:
				btn_set = btn_acportop;
				break;
			case AC_PORT_MON:
				btn_set = btn_acportmon;
				break;
			case ALL_NO:
				btn_set = btn_allno;
			default:
				btn_set = btn_noport;
				break;
		}
		
		for (int i=0; i<button.length; i++){
			if (btn_set[i]==1){
				button[i].setEnabled(true);				
			} else {
				button[i].setEnabled(false);								
			}
		}
		for (int i=0; i<tglbtn.length; i++){
			if (btn_set[button.length-1]==1){
				tglbtn[i].setEnabled(true);				
			} else {
				tglbtn[i].setEnabled(false);								
			}			
		}
	}

	public static void main(String[] args) {
		// TODO 自動生成されたメソッド・スタブ
		Dipplc_chk card = new Dipplc_chk();
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		// TODO 自動生成されたメソッド・スタブ
		JToggleButton btn = (JToggleButton)e.getSource();
		int no=0;
		if (btn==tglbtn[0]){
			no = 0;
		} else if (btn==tglbtn[1]){
			no = 1;			
		} else if (btn==tglbtn[2]){
			no = 2;
		} else if (btn==tglbtn[3]){
			no = 3;
		} else if (btn==tglbtn[4]){
			no = 4;			
		} else if (btn==tglbtn[5]){
			no = 5;
		}
		
		if (btn.isSelected()){
			if (tglstate[no]==0){
				SendCmd("Y0" + no + "=1");
				tglstate[no] = 1;
			}
		} else {
			if (tglstate[no]==1){
				SendCmd("Y0" + no + "=0");
				tglstate[no] = 0;
			}
		}
	}
}
